import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
/**
 * This code is borrowed from Mr. Cohen, but I just edited some colours and did some modifying
 * @David Zhang
 * @Jan 21st, 2013
 */
public class EndScreen extends Actor
{
    //Declaring instance variables and colours
    private GreenfootImage scoreBoard;
    private Color backgroundColor = new Color (176, 176, 176);
    private Color textColor = new Color (176,0,0);
    private Font textFont = new Font ("Arial", Font.BOLD, 52);

    /**
     * This is the constructor for the EndScreen
     */
    public EndScreen()
    {
        //new EndScreen will be 450 pixels by 180 pixels
        scoreBoard = new GreenfootImage(450, 180);
        //Set the font of the scoreboard to the font
        scoreBoard.setFont (textFont);
        //Set the colour to the colour that I declared.
        scoreBoard.setColor (backgroundColor);
        //Fill the colour and set the image as scoreboard
        scoreBoard.fill();
        this.setImage(scoreBoard);
    }

    /**
     * This is method where it updates the score in the world.
     */
    public void setScore (int lives)
    {
        String s = "Final Score: " + lives;
        String g = "Game Over";
        // erase everything in score and start again
        scoreBoard.clear();
        scoreBoard.setColor (backgroundColor);
        scoreBoard.fill();
        scoreBoard.setColor (textColor);
        scoreBoard.drawString (s, 5, 150);
        scoreBoard.drawString (g, 75, 75);
    }

}