import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is the power up that the beggar drops and it gives the man object health IF he doesn't already have full health
 * 
 * @David Zhang
 * @Jan 20th 2013
 */
public class Fish extends Beggar
{
    //This is where I declare all my intance variables that I am going to use in this class
    private GreenfootImage[] fish = new GreenfootImage[6];
    private int frames = 0;
    private int timeCount = 153;
    /**
     * This is where I declare what all the fish class must have when they spawn, I used a for loop to declare all the images so it would be more effienct 
     * than the ones where I declared all the pictures one by one in the man class. I know, I should have done that, but I'm too lazy to change that.
     */
    public Fish()
    {
        //Intialize the integer x, and as long as x is smaller than, 5, this code runs, and what it does is that it inputs pictures into the greenfootImage
        // array which contains all the images to animate the fish.
        for(int x = 0; x <= 5; x++)
        {
            fish[x] = new GreenfootImage("Fish"+ x +".png");
        }
    }

    /**
     * Act - do whatever the Fish wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        animate();
        timer();
    }    
    
    /**
     * This is a method which counts down the time the class has in the world until it removes itself, it has 153 acts until it removes itself.
     */
    private void timer()
    {
        //This subtracts itself by one everytime this method is called.
        timeCount--;
        //And when the counter comes to a zero, it runs the method removeMe() which removes the object from this world.
        if (timeCount ==0)
        {
            removeMe();
        }
    }

    /**
     * This method is
     */
    public void removeMe()
    {
        getWorld().removeObject(this);
    }

    private void animate()
    {
        if (frames == 1)
        {
            setImage(fish[0]);
        }
        else if(frames == 11)
        {
            setImage(fish[1]);
        }
        else if(frames == 21)
        {
            setImage(fish[2]);
        }
        else if(frames == 31)
        {
            setImage(fish[3]);
        }
        else if(frames == 41)
        {
            setImage(fish[4]);
        }
        else if(frames == 51)
        {
            setImage(fish[5]);
            frames = 0;
        }
        frames++;
    }
}
