import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
/**
 * This code is borrowed from Mr. Cohen, but I just edited some colours and did some modifying
 * 
 */

public class LifeCounter extends Actor
{
    //Declaring instance variables and colours
    private GreenfootImage scoreBoard;
    private Color backgroundColor = new Color (0, 176, 0);
    private Color textColor = new Color (176,0,0);
    private Font textFont = new Font ("Arial", Font.BOLD, 28);

    /**
     * This is the constructor for the LifeCounter
     */
    public LifeCounter()
    {
        //new scoreboard will be 150 pixels by 40 pixels
        scoreBoard = new GreenfootImage(150, 40);
        //Set the font of the scoreboard to the font
        scoreBoard.setFont (textFont);
        //Set the colour to the colour that I declared.
        scoreBoard.setColor (backgroundColor);
        //Fill the colour and set the image as scoreboard
        scoreBoard.fill();
        this.setImage(scoreBoard);
    }

    /**
     * This is method where it updates the score in the world.
     */
    public void setScore (int lives)
    {
        String s = "Lives: " + lives;
        // erase everything in score and start again
        scoreBoard.clear();
        scoreBoard.setColor (backgroundColor);
        scoreBoard.fill();
        scoreBoard.setColor (textColor);
        scoreBoard.drawString (s, 5, 32);
    }
}
