import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is the only thing that the user controls, and this is  
 * 
 * @David Zhang
 * @Jan 18, 2013
 */
public class Man extends Actor
{
    //This is where I state the all the instances of this class
    private GreenfootImage regular;
    private GreenfootImage regularLeft;
    private GreenfootImage moveRight;
    private GreenfootImage moveLeft, moveLeft2;
    //This hitPoints is different than the one in world, this one is how many times left that he can get hit
    private int hitPoints = 9;
    private GreenfootSound die;
    boolean faceRight = true;
    private int frames = 1;
    private GreenfootImage[] runningLeft = new GreenfootImage[8];
    private GreenfootImage[] runningRight = new GreenfootImage[8];
    private GreenfootImage[] dieRight = new GreenfootImage[9];

    /**
     * Constructor for the Man class
     * Contains all the images for the different things that it is going to do such as moving and dying
     */
    public Man()
    {
        regular = new GreenfootImage("Untitled-2.png");
        //moveRight = new GreenfootImage("movementRight.png");
        regularLeft= new GreenfootImage("stayLeft.png");
        //Inputting the images to the array of images that will be the movements for the Man to move left and righ
        runningLeft[0] = new GreenfootImage("RunningLeft.PNG");
        runningLeft[1] = new GreenfootImage("RunningLeft2.PNG");
        runningLeft[2] = new GreenfootImage("RunningLeft3.PNG");
        runningLeft[3] = new GreenfootImage("RunningLeft4.PNG");
        runningLeft[4] = new GreenfootImage("RunningLeft5.PNG");
        runningLeft[5] = new GreenfootImage("RunningLeft6.PNG");
        runningLeft[6] = new GreenfootImage("RunningLeft7.PNG");
        runningLeft[7] = new GreenfootImage("RunningLeft8.PNG");

        //These are all the images that will be used when the user presses right on the keyboard
        runningRight[0] = new GreenfootImage("movementRight.png");
        runningRight[1] = new GreenfootImage("movementRight2.PNG");
        runningRight[2] = new GreenfootImage("movementRight3.PNG");
        runningRight[3] = new GreenfootImage("movementRight4.PNG");
        runningRight[4] = new GreenfootImage("movementRight5.PNG");
        runningRight[5] = new GreenfootImage("movementRight6.PNG");
        runningRight[6] = new GreenfootImage("movementRight7.PNG");
        runningRight[7] = new GreenfootImage("movementRight8.PNG");

        //These are all the images that will be used when the character dies
        dieRight[0] = new GreenfootImage("Die1.PNG");
        dieRight[1] = new GreenfootImage("Die2.PNG");
        dieRight[2] = new GreenfootImage("Die3.PNG");
        dieRight[3] = new GreenfootImage("Die4.PNG");
        dieRight[4] = new GreenfootImage("Die5.PNG");
        dieRight[5] = new GreenfootImage("Die6.PNG");
        dieRight[6] = new GreenfootImage("Die7.PNG");
        dieRight[7] = new GreenfootImage("Die8.PNG");
        dieRight[8] = new GreenfootImage("Die9.PNG");

        die =  new GreenfootSound("Marco Zombie.wav");
    }

    /**
     * Act - do whatever the man wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        acting();   
    }

    /**
     * Every time the act method is called, these separate methods would be called too.
     * When hit points is bigger than 0, the top two methods are called
     * When hit points reaches 0, the last method die() is called.
     */
    private void acting()
    { 
        //Import background and get method gameRunning, and if main.gameRunning is true, run the following code.
        Background main = (Background)getWorld();
        if(main.gameRunning())
        {
            //If hit points is bigger than 0, run this code
            if (hitPoints > 0)
            {
                move();
                checkForHit();
                checkForFish();
                checkForChicken();
            }
            //Otherwise run this following code, this pretty much only runs when the man doesn't have anymore health
            else
            {
                die();
            }   
        }
    }

    /**
     * Checks if there are Martians Bullets coming into contact with the Man class, if there its, it subtracts health from the health bar and then it removes the 
     * Martian bullet
     */
    public void checkForHit()
    {
        //Importing the Class Martian bullet and its methods and names it m
        MartianBullet m = (MartianBullet)getOneIntersectingObject (MartianBullet.class);
        //If m is not null, meaning that if there is a Martian bullet that is collision with this class, the following will happen, it will call
        // the world class and methods that is within the background class that is public
        if (m != null)
        {
            Background t = (Background) getWorld();
            t.subtractHealth();
            m.removeMe();
            hitPoints --;
        }
    }

    /**
     * This is a method that checks if the Man object is coming into contact with a fish class, if it is then run this code.
     */
    public void checkForFish()
    {
        //Importing the Class Fish and its methods and names it f
        Fish f = (Fish)getOneIntersectingObject (Fish.class);
        //If f is not null, meaning that if there is a Fish that is collision with this class, the following will happen, it will call
        // the world class and methods that is within the background class that is public
        if (f != null)
        {
            //Also this checks if the hit points is 9 or not, if it is 9, that means the man has full health, so he doesn't need more hp.
            if(hitPoints%3!= 0)
            {
                Background t = (Background) getWorld();
                t.addHealth();
                f.removeMe();
                hitPoints++;
            }
        }
    }

    /**
     * This is a method that checks if the Man object is coming into contact with a chicken class, if it is then run this code.
     */
    public void checkForChicken()
    {
        //Importing the Class Chicken and its methods and names it c
        Chicken c = (Chicken)getOneIntersectingObject (Chicken.class);
        //If c is not null, meaning that if there is a Chicken that is collision with this class, the following will happen, it will call
        // the world class and methods that is within the background class that is public
        if (c != null)
        {
            //Get background, name it t, and run the following methods from the background class.
            Background t = (Background) getWorld();
            t.addLife();
            c.removeMe();
            hitPoints+=3;

        }
    }

    /**
     * This is a method which makes the character die, when his hit point reaches 0, this runs every act, but only does something when hit points = 0 
     */
    private void die()
    {
        die.play();
        //every 10 frames, the pictures switch betweeen each other so to animate the feel of him dying
        if (frames == 1)
        {
            setImage(dieRight[0]);

        }
        else if(frames == 11)
        {
            setImage(dieRight[1]);
        }
        else if(frames == 21)
        {
            setImage(dieRight[2]);
        }
        else if(frames == 31)
        {
            setImage(dieRight[3]);
        }
        else if(frames == 41)
        {
            setImage(dieRight[4]);
        }
        else if(frames == 51)
        {
            setImage(dieRight[5]);
        }
        else if(frames == 61)
        {
            setImage(dieRight[6]);
        }
        else if(frames == 71)
        {
            setImage(dieRight[7]);
        }
        else if(frames == 81)
        {
            setImage(dieRight[8]);
        }
        else if(frames == 91)
        {
            //Calls the calls background and uses it;
            Background b = (Background) getWorld();
            b.gameOver();
        }
        //this increases the counter integer frames
        frames++;
    }

    /**
     * This is the method that moves the Man if there is user input from the user
     */
    private void move()
    {
        //If the user presses right and the x coordinates of the object is smaller than 725, this following code runs
        if (Greenfoot.isKeyDown("right") && getX() < 725) {
            //this is how my object moves, by increasing the x coordinate by 5
            setLocation (getX()+ 5, getY());
            //every 3 frames, the image changes
            if (frames == 1)
            {
                setImage(runningRight[0]);
            }
            else if(frames == 4)
            {
                setImage(runningRight[1]);
            }
            else if(frames == 7)
            {
                setImage(runningRight[2]);
            }
            else if(frames == 10)
            {
                setImage(runningRight[3]);
            }
            else if(frames == 13)
            {
                setImage(runningRight[4]);
            }
            else if(frames == 16)
            {
                setImage(runningRight[5]);
            }
            else if(frames == 19)
            {
                setImage(runningRight[6]);
            }
            else if(frames == 22)
            {
                setImage(runningRight[7]);
                frames= 1;
            }
            //This increases frames by one.
            frames++;
            //This makes the boolean faceRight into to true
            faceRight= true;
        }
        //When the user does not press right or anything, and is facing right, this sets the image of the object to the regular facing right picture.
        if (!Greenfoot.isKeyDown("right") && faceRight) {
            setImage(regular);
        }
        //If the user presses left, this following code runs
        if (Greenfoot.isKeyDown("left")) {
            //this is how my object moves, by decreasing the x coordinate by 5
            setLocation (getX() - 5, getY());
            //every 3 frames, the image changes 
            if (frames == 1)
            {
                setImage(runningLeft[0]);
            }
            else if(frames == 4)
            {
                setImage(runningLeft[1]);
            }
            else if(frames == 7)
            {
                setImage(runningLeft[2]);
            }
            else if(frames == 10)
            {
                setImage(runningLeft[3]);
            }
            else if(frames == 13)
            {
                setImage(runningLeft[4]);
            }
            else if(frames == 16)
            {
                setImage(runningLeft[5]);
            }
            else if(frames == 19)
            {
                setImage(runningLeft[6]);
            }
            else if(frames == 22)
            {
                setImage(runningLeft[7]);
                frames= 1;
            }
            //This turns the boolean faceRight into false because he just moved left so he shouldn't be facing right
            faceRight= false;
            //This increases frames by one.
            frames ++;
        }
        //When the user does not press left or anything, and is facing left, this sets the image of the object to the regular facing left picture.
        if (!Greenfoot.isKeyDown("left" )&& !faceRight) {
            setImage(regularLeft);
        }
        //If the user presses up, the following code runs
        if (Greenfoot.isKeyDown("up") && getY()> 70)
        {
            //this is how the object moves, by decreasing the y coordinate by 5
            setLocation(getX(), getY() - 5);
        }
        //If the user presses down, the follwoing code runs
        if (Greenfoot.isKeyDown("down") && getY() < 355)
        {
            //this is how the object moves, by increasing the y coordinate by 5
            setLocation(getX(), getY() + 5);
        }
    }
}
